=== modified file 'bzrlib/diff.py'
--- bzrlib/diff.py	2008-01-03 16:01:06 +0000
+++ bzrlib/diff.py	2008-01-04 00:26:05 +0000
@@ -388,9 +388,11 @@
 
     other_paths = []
     make_paths_wt_relative = True
+    consider_relpath = True
     if path_list is None or len(path_list) == 0:
-        # If no path is given, assume the current directory
+        # If no path is given, the current working tree is used
         default_location = u'.'
+        consider_relpath = False
     elif old_url is not None and new_url is not None:
         other_paths = path_list
         make_paths_wt_relative = False
@@ -404,7 +406,7 @@
         old_url = default_location
     working_tree, branch, relpath = \
         bzrdir.BzrDir.open_containing_tree_or_branch(old_url)
-    if relpath != '':
+    if consider_relpath and relpath != '':
         specific_files.append(relpath)
     old_tree = _get_tree_to_diff(old_revision_spec, working_tree, branch)
 
@@ -414,7 +416,7 @@
     if new_url != old_url:
         working_tree, branch, relpath = \
             bzrdir.BzrDir.open_containing_tree_or_branch(new_url)
-        if relpath != '':
+        if consider_relpath and relpath != '':
             specific_files.append(relpath)
     new_tree = _get_tree_to_diff(new_revision_spec, working_tree, branch,
         basis_is_default=working_tree is None)

=== modified file 'bzrlib/tests/blackbox/test_diff.py'
--- bzrlib/tests/blackbox/test_diff.py	2007-12-04 06:39:55 +0000
+++ bzrlib/tests/blackbox/test_diff.py	2008-01-04 00:26:05 +0000
@@ -259,6 +259,14 @@
         output = self.run_bzr('diff -r 1.. branch1', retcode=1)
         self.assertContainsRe(output[0], '\n\\-original line\n\\+new line\n')
 
+    def test_diff_to_working_tree_in_subdir(self):
+        self.example_branch2()
+        self.build_tree_contents([('branch1/file1', 'new line')])
+        os.mkdir('branch1/dir1')
+        os.chdir('branch1/dir1')
+        output = self.run_bzr('diff -r 1..', retcode=1)
+        self.assertContainsRe(output[0], '\n\\-original line\n\\+new line\n')
+
     def test_diff_across_rename(self):
         """The working tree path should always be considered for diffing"""
         tree = self.make_example_branch()

